;###########################################################################
;    This file is part of KillingMachine game made by PizzarT.
;
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;
;###########################################################################

;###########################################################################
;#### FICHERO: entity.h.s
;###########################################################################

.include "render.h.s"

k_size_de = 6

.macro DefineMovableEntity _name, _x, _y, _w, _h, _sp, _vx, _vy, _movsX, _movsY, _upd
_name: 
   DefineDrawableEntity _name'_dw, _x, _y, _w, _h, _sp
   .db   _vx, _vy     		;; Velocidad X, Velocidad Y
   .db	_movsX, _movsY 	;; Cuantas posiciones se desplaza en los ejes
   .dw   _upd        		;; Update 
.endm
k_size_mov_ent = k_size_de + 6 

e_vx    = 0 + k_size_de    e_vy    = 1 + k_size_de
e_movsX = 2 + k_size_de    e_movsY = 3 + k_size_de
e_up_l  = 4 + k_size_de    e_up_h  = 5 + k_size_de



.macro DefineBulletEntity _name, _x, _y, _w, _h, _sp, _vx, _vy, _movsX, _movsY, _upd, _dirX, _dirY, _pw
_name: 
   DefineMovableEntity _name'_ent, _x, _y, _w, _h, _sp, _vx, _vy, _movsX, _movsY, _upd
   .db   _dirX, _dirY   ;; Direccion hacia donde se mueve la bala
   .db   _pw            ;; Power
.endm

be_dirX = 0 + k_size_mov_ent  be_dirY = 1 + k_size_mov_ent
be_pw   = 2 + k_size_mov_ent


.macro DefineBulletEntityDefault _name, _suf
   DefineBulletEntity _name'_suf, 0xAA, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xFF
.endm

.macro DefineNBulletsEntities _name, _n
   _c = 0
   .rept _n
      DefineBulletEntityDefault _name, \_c
      _c = _c + 1
   .endm
.endm




.macro DefineCharacterEntity _name, _x, _y, _w, _h, _sp, _vx, _vy, _movsX, _movsY, _upd, _hp, _tFire, _tMaxFire
_name:
   DefineMovableEntity _name'_ent, _x, _y, _w, _h, _sp, _vx, _vy, _movsX, _movsY, _upd
   .db   _hp         ;; Puntos de salud
   .db   _tFire      ;; Tiempo entre disparo y disparo
   .db   _tMaxFire   ;; Tiempo max. entre un disparo y otro
.endm
k_size_ce = k_size_mov_ent + 3

ce_hp     = 0 + k_size_mov_ent
ce_tFire  = 1 + k_size_mov_ent
ce_tMaxF  = 2 + k_size_mov_ent


.macro DefineEnemyEntity _name, _x, _y, _w, _h, _sp, _vx, _vy, _movsX, _movsY, _upd, _hp, _tFire, _tMaxFire, _nextX, _nextY, _tMove, _tmaxMove, _bullet
_name:
   DefineCharacterEntity _name'_ce, _x, _y, _w, _h, _sp, _vx, _vy, _movsX, _movsY, _upd, _hp, _tFire, _tMaxFire
   .db   _nextX, _nextY    ;; Prox. X e Y a las que tiene que moverse
   .db   _tMove            ;; Tiempo para siguiente movimiento
   .db   _tmaxMove         ;; Tiempo max. entre un movimiento y otro
   .dw   _bullet
.endm

enem_nextX = 0 + k_size_ce    enem_nextY = 1 + k_size_ce
enem_tMove = 2 + k_size_ce
enem_tMaxM = 3 + k_size_ce
enem_b_l = 4 + k_size_ce    enem_b_h = 5 + k_size_ce


.macro DefineEnemyEntityDefault _name, _suf
   DefineEnemyEntity _name'_suf, 0xAA, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xFF
.endm

.macro DefineNEnemyEntities _name, _n
   _c = 0
   .rept _n
      DefineEnemyEntityDefault _name, \_c
      _c = _c + 1
   .endm
.endm



.globl ent_update

.globl ent_spawnearEnemy

.globl ent_new
.globl ent_delete
.globl ent_copy
.globl ent_doForAll

.globl ent_updateEntities

.globl ent_initDrawableEntityVector

.globl ent_initHeroStats
.globl ent_regeneraHealth
.globl ent_removeHeartHeroStats


.globl hero_data

;; Variables para las oleadas
.globl m_num_enemies_pant
.globl m_num_total_enemies

.globl enemy_data
.globl enemy_bomb_data
.globl enemy_tower_data

.globl enemyBullet_data
.globl towerBullet_data

.globl m_t_max_spawn
.globl m_t_spawn

.globl m_num_enemies

.globl m_max_t_regen
.globl m_t_regen

.globl m_tMax_move_SP


;; Hay que reiniciar estas variables
.globl m_num_enemies
.globl m_next_enemy
.globl enemy_vector

.globl m_num_enemyBullets
.globl m_next_enemyBullet
.globl enemyBullet_vector

.globl m_num_heroBullets
.globl m_next_heroBullet
.globl heroBullet_vector
