;###########################################################################
;    This file is part of KillingMachine game made by PizzarT.
;
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;
;###########################################################################

;###########################################################################
;#### FICHERO: entity.s
;###########################################################################
.include "cpctelera.h.s"
.include "entity.h.s"
.include "main.h.s"

;; Spawns
k_spw_izq_x = #0x04
k_spw_izq_y = #0x55 ;; 85

k_spw_sup_x = #0x28 ;; 40
k_spw_sup_y = #0x10

k_spw_der_x = #0x4C
k_spw_der_y = #0x55 ;; 85

;; Limites del mapa
k_limit_izq_x  = #0x04
k_limit_der_x  = #0x4C  ;; 79 - 3
k_limit_up_y   = #0x10
k_limit_down_y = #0xAF  ;; 199 

;; Direccion de las entidades
k_izquierda = 1
k_derecha   = 2
k_arriba    = 3
k_abajo     = 4


;; Vector de enemigos
enemy_vector:
DefineNEnemyEntities enemy_vector, k_max_num_enemies

;; Datos vector enemigos
k_max_num_enemies = 7
k_enemy_size = 21

m_num_enemies: .db 00
m_next_enemy:  .dw enemy_vector



k_bullet_size = 15

;; Vector de balas enemigas
enemyBullet_vector:
DefineNBulletsEntities enemyBullet_vector, k_max_num_enemyBullets

;; Datos vector balas enemigas
k_max_num_enemyBullets = 20

m_num_enemyBullets:  .db 00
m_next_enemyBullet:  .dw enemyBullet_vector



;; Vector de balas del hero
heroBullet_vector:
DefineNBulletsEntities heroBullet_vector, k_max_num_heroBullets

;; Datos vector balas de hero
k_max_num_heroBullets = 10

m_num_heroBullets:  .db 00
m_next_heroBullet:  .dw heroBullet_vector


;; Vector de entidades dibujables para el borrado del back_buffer
drawableEntities_vector:
DefineNDrawablesEntities drawableEntities_vector, k_max_drawableEntities

k_max_drawableEntities = k_max_num_enemies + k_max_num_enemyBullets + k_max_num_heroBullets
k_dEntity_size = 6

m_num_drawableEntities: .db 00
m_next_dEntity: .dw drawableEntities_vector



k_max_heroHealth = 12

heroHealth_vector: 
.db #0x35, #0x3B, #0x41, #0x47, #0x4D, #0x53, #0x59, #0x5F, #0x65, #0x6B, #0x71, #0x77

m_actual_heroHealth: .dw heroHealth_vector


;; Hero name, x, y, w, h, col, vx, vy, movsX, movsY, upd, hp, tFire, tMaxFire
DefineCharacterEntity hero_data,  0x27, 0x64, 0x08, 0x10, _heroe_sp, 0x00, 0x00, #2, #4, ent_controlKeyboard, #12, #0, #7

;; Enemy template name, x, y, w, h, col, vx, vy, movsX, movsY, upd, hp, tFire, tMaxFire, nextX, nextY, tMove, tMaxMove
DefineEnemyEntity enemy_data, 0x14, 0x2B, 0x08, 0x10, _spider_sp, 0x00, 0x00, #1, #2, ent_moveEnemyRandom, #3, #15, #30, #0x14, 0x2B, #200, #200, #enemy_bullet

DefineEnemyEntity enemy_bomb_data, 0x14, 0x2B, 0x08, 0x10, _enemy_bomb_sp, 0x00, 0x00, #1, #8, ent_moveEnemyBomb, #2, #1, #30, #0x14, 0x2B, #1, #0, #enemy_bullet

DefineEnemyEntity enemy_tower_data, 0x14, 0x2B, 0x08, 0x10, _tower_sp, 0x00, 0x00, #0, #0, ent_moveTower, #5, #50, #50, #0x14, 0x2B, #1, #0, #tower_bullet

;; Bullet template name, x, y, w, h, col, vx, vy, movsX, movsY, upd, dirX, dirY, pw
DefineBulletEntity heroBullet_data 0x00, 0x00, 0x04, 0x08, _bala_sp, 0x00, 0x00, #4, #8, ent_moveHeroBullet, #2, #0, #1

enemy_bullet:
DefineBulletEntity enemyBullet_data 0x00, 0x00, 0x04, 0x08, _bala_spider_sp, 0x00, 0x00, #2, #5, ent_moveEnemyBullet, #0, #0, #1

tower_bullet:
DefineBulletEntity towerBullet_data 0x00, 0x00, 0x04, 0x08, _bala_tower_sp, 0x00, 0x00, #2, #5, ent_moveEnemyBullet, #0, #0, #3

DefineDrawableEntity heart, 0xC7, 0x35, 0x04, 0x08, _health_sp


m_num_enemies_pant: .db 00
m_num_total_enemies: .db 00

m_tMax_fire: .db #00

m_tMax_fire_SP: .db #30
m_tMax_move_SP: .db #200

m_tMax_fire_TW: .db #50

;; Tiempo para spawnear
m_t_max_spawn: .db 00
m_t_spawn: .db 00


;; Minimo movimiento a realizar
m_min_mov: .db 00

;; Direccion de la bala que se dispara
m_bullet_X: .db #2
m_bullet_Y: .db #0

next_entity: .dw #0

entity_killed: .db #0

movs_bullet: .db #0

bullet_erased: .db #0

entity_size: .dw #0

m_max_t_regen: .db #50
m_t_regen: .db #50

change_enemy: .db #1


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	INICIALIZA LAS VIDAS EN PANTALLA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_initHeroStats:
	ld 	a, #k_max_heroHealth
	ld 	ix, #heroHealth_vector
buc_health:
	push 	af
	ld 	a, (ix)
	ld 	e, a
	call  rend_drawHeroStats
	pop 	af

	inc 	ix

	dec 	a
	jr 	nz, buc_health
		dec 	ix
		push 	ix
		pop 	hl
		ld 	(m_actual_heroHealth), hl

	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	BORRA UNA VIDA DE LA PANTALLA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_removeHeartHeroStats:
	ld 	a, d
buc_rHerats:
	ld 	hl, (m_actual_heroHealth)
	ld 	e, (hl)
	push 	af
	call 	rend_removeHeartHero
	pop 	af

	ld 	hl, (m_actual_heroHealth)
	dec 	hl
	ld 	(m_actual_heroHealth), hl

	dec 	a
	jr 	nz, buc_rHerats
		ld 	a, (m_max_t_regen)
		ld 	(m_t_regen), a

	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	REGENERA LA VIDA DEL PERSONAJE CADA CIERTO TIEMPO
;; ENTRADA:
;;			IX -> Puntero a hero
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_regeneraHealth:
	ld 	a, (m_t_regen)
	add 	#0
	jr 	nz, no_regen 				;; Aun no se puede regenerar
		;; Es hora de regenerarse
		ld 	a, ce_hp(ix)
		cp 	#k_max_heroHealth
		jr 	z, reset_t_regen		;; Si Z=1, tiene todas las vidas
			;; Regeneracion
			ld 	iy, (m_actual_heroHealth)
			inc 	iy
			ld 	a, (iy)
			ld 	e, a
			call 	rend_drawHeroStats

			ld 	a, ce_hp(ix)
			inc 	a
			ld 	ce_hp(ix), a

			push 	iy
			pop 	hl
			ld 	(m_actual_heroHealth), hl


reset_t_regen:
	ld 	a, (m_max_t_regen)
	srl 	a
	srl 	a
	ld 	(m_t_regen), a
	jr 	fin_regen

no_regen:
	dec 	a
	ld 	(m_t_regen), a

fin_regen:
	ret





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; COPIA UN VECTOR EN EL VECTOR DE ENTIDADES DIBUJABLES
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IY
;; ENTRADA: 
;; 		IY -> Puntero al vector a copiar
;;			 A -> Numero de entidades del vector
;; 		
;; 		entity_size -> size de las entidades del
;;								vector en IY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_copyVectorToDrawableVector:
	add 	#0
	jr 	z, fin_copyVector
buc_copyVector:
		ld 	hl, (m_next_dEntity)
		ld 	(next_entity), hl

		ld 	hl, #m_num_drawableEntities
		ld 	bc, #k_dEntity_size

		push 	af
		call 	ent_new
		pop 	af
		push 	hl
		ld 	hl, (next_entity)
		ld 	(m_next_dEntity), hl
		pop 	hl

		ex 	de, hl
		push 	iy
		pop 	hl
		call 	ent_copy
		
		ld 	d, #0
		ld 	de, (entity_size)
		add 	iy, de
		dec 	a
		jr 	nz, buc_copyVector

fin_copyVector:
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; INICIALIZA UN VECTOR CON LOS DATOS NECESARIOS 
;; PARA DIBUJAR UNA ENTIDAD EN UN VECTOR
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_initDrawableEntityVector:
	ld 	a, #0
	ld 	(m_num_drawableEntities), a

	ld 	hl, #drawableEntities_vector
	ld 	(m_next_dEntity), hl

	;; Hero
	ld 	bc, #k_dEntity_size

	ld 	(next_entity), hl
	ld 	hl, #m_num_drawableEntities

	call 	ent_new
	push 	hl 
	ld 	hl, (next_entity)
	ld 	(m_next_dEntity), hl
	pop 	hl

	ex 	de, hl
	ld 	hl, #hero_data
	call 	ent_copy

	;; Enemies
	ld 	iy, #enemy_vector
	ld 	hl, #k_enemy_size
	ld 	(entity_size), hl
	ld 	a, (m_num_enemies)
	call 	ent_copyVectorToDrawableVector

	;; Enemy bullets
	ld 	iy, #enemyBullet_vector
	ld 	hl, #k_bullet_size
	ld 	(entity_size), hl
	ld 	a, (m_num_enemyBullets)
	call 	ent_copyVectorToDrawableVector

	;; Hero bullets
	ld 	iy, #heroBullet_vector
	ld 	a, (m_num_heroBullets)
	call 	ent_copyVectorToDrawableVector
	
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MUEVE UNA BALA
;; REGISTROS DESTRUIDOS: 
;; ENTRADA: 
;; 		IX -> Bala a mover
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_moveEnemyBullet:
	ld 	hl, #ent_checkColisionForEnemyBullet
	ld 	(checkColisionX), hl
	ld 	(checkColisionY), hl

	call 	ent_moveBullet	

	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MUEVE UNA BALA
;; REGISTROS DESTRUIDOS: 
;; ENTRADA: 
;; 		IX -> Bala a mover
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_moveHeroBullet:
	ld 	hl, #ent_checkColisionForHeroBullet
	ld 	(checkColisionX), hl
	ld 	(checkColisionY), hl

	call 	ent_moveBullet

	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ACTUALIZA LA SALUD DE UNA ENTIDAD CUANDO LA DANYAN
;; Y DETERMINA SI LA MATAN
;; REGISTROS DESTRUIDOS: 
;; ENTRADA: 
;; 		IX -> Puntero a la bala
;; 		IY -> Puntero a la entidad danyada
;;			B -> Daño a quitar
;; SALLIDA:
;; 		D -> Numero de corazones a borrar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_damageEntity:
	ld 	d, b
	ld 	a, ce_hp(iy)
	cp 	b
	jr 	z, mata_entidad
	jr 	c, mata_entidad
		sub 	b
		ld 	ce_hp(iy), a
		jr 	fin_damageEntity

mata_entidad:
	ld 	d, ce_hp(iy)
	ld 	a, #0
	ld 	ce_hp(iy), a
	ld 	a, #1
	ld 	(entity_killed), a

fin_damageEntity:
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DETECTA LA COLISION DE LA BALA
;; REGISTROS DESTRUIDOS: AF, BC, D
;; ENTRADA: 
;; 		 C -> Direccion a la que quiere moverse IX
;; 		 D -> Numero de pos a mover
;; SALIDA:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_checkColisionBullet:
	ld 	e, d

	ld 	a, c 								;; Cargo la direccion del movimiento en A
	sub 	#k_izquierda 					;; Compruebo si es izquierda
	jr 	z, check_colisionLoU 		;; Z=1 -> es izquierda
		ld 	a, c 
		sub 	#k_derecha
		jr 	z, check_colisionRoD 	;; Z=1 -> es derecha
			ld 	a, c 
			sub 	#k_abajo
			jr 	z, check_colisionRoD ;; Z=1 -> es abajo
				;; Arriba 					;; Z=0 -> es arriba

check_colisionLoU:
	ld 	a, d 					;; A = D
	neg 							;; Lo pasamos a positivo
	ld 	e, a 					;; Lo ponemos en E

check_colisionRoD:
	ld 	a, (movs_bullet) 	;; Cargamos los movs que hace como max
	ld 	b, a 					;; B = A
	ld 	a, e 					;; A =  E
	cp 	b 						

	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DETECTA SI LA BALA IX COLISIONA CONTRA OTRA
;; ENTIDAD SEGUN EL MOVIMIENTO QUE QUIERE REALIZAR
;; REGISTROS DESTRUIDOS: AF, BC, D
;; ENTRADA: 
;; 		IX -> Puntero a entidad
;; 		 C -> Direccion a la que quiere moverse IX
;; SALIDA:
;; 		D -> Numero de posiciones a mover
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_checkColisionForEnemyBullet:
	ld 	a, #0
	ld 	(entity_killed), a

	call 	ent_checkColisionMap

	call 	ent_checkColisionBullet
	jr 	c, destroy_enemyBullet

	ld 	a, d
	add 	#0
	jr 	z, destroy_enemyBullet

	ld 	iy, #hero_data

	call 	ent_checkColisionEnt 		;; Comprobamos colision con IY
	call 	ent_checkColisionBullet
	jr 	c, damage_hero

	ld 	a, d
	add 	#0
	jr 	z, damage_hero
		jr 	fin_checkColisionFEB

damage_hero:
	ld 	b, be_pw(ix)
	call 	ent_damageEntity
	call 	ent_removeHeartHeroStats
	ld 	a, (entity_killed)
	sub 	#1
	jr 	nz, destroy_enemyBullet
		;; Hero ha muerto
		ld 	a, #1
		ld 	(m_game_over), a

destroy_enemyBullet:
	ld 	a, #-1 					;; Indicamos que se ha borrado 
	ld 	(bullet_erased), a

	ld 	hl, (m_next_enemyBullet)
	ld 	(next_entity), hl

	ld 	hl, #m_num_enemyBullets
	ld 	bc, #k_bullet_size

	call 	ent_deleteEntity

	ld 	hl, (next_entity)
	ld 	(m_next_enemyBullet), hl

	ld 	bc, #k_bullet_size
	push 	ix
	pop 	hl
	sbc 	hl, bc
	push 	hl
	pop 	ix

fin_checkColisionFEB:
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DETECTA SI LA BALA IX COLISIONA CONTRA OTRA
;; ENTIDAD SEGUN EL MOVIMIENTO QUE QUIERE REALIZAR
;; REGISTROS DESTRUIDOS: AF, BC, D
;; ENTRADA: 
;; 		IX -> Puntero a entidad
;; 		 C -> Direccion a la que quiere moverse IX
;; SALIDA:
;; 		D -> Numero de posiciones a mover
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_checkColisionForHeroBullet:
	ld 	a, #0
	ld 	(entity_killed), a

	call 	ent_checkColisionMap

	call 	ent_checkColisionBullet
	jr 	c, destroy_heroBullet

	ld 	a, d
	add 	#0
	jr 	z, destroy_heroBullet

	ld 	iy, #enemy_vector

	ld 	a, (m_num_enemies)		;; Cargamos en A el numero de entidades actuales
	sub 	#0 							;; Restamos 0
	jr 	z, fin_checkColisionFHB ;; Z=1, no hay entidades
buclde_colisionFHB:
		ex 	af, af'
		call 	ent_checkColisionEnt ;; Comprobamos colision con IY
		call 	ent_checkColisionBullet
		jr 	c, damage_enemy

		ld 	a, d
		add 	#0
		jr 	z, damage_enemy
			ex 	af, af'

		push 	bc
		ld 	bc, #k_enemy_size   ;; Avanzamos a la siguiente
		add 	iy, bc
		pop 	bc

		dec 	a
		jr 	nz, buclde_colisionFHB
			jr fin_checkColisionFHB

damage_enemy:
	ld 	b, be_pw(ix)
	call 	ent_damageEntity
	ld 	a, (entity_killed)
	sub 	#1
	jr 	nz, destroy_heroBullet
		;; Has matado al enemigo
		ld 	hl, (m_next_enemy)
		ld 	(next_entity), hl

		ld 	hl, #m_num_enemies
		ld 	bc, #k_enemy_size

		push	ix
		push 	iy
		pop 	ix
		call 	ent_deleteEntity
		pop 	ix

		ld 	hl, (next_entity)
		ld 	(m_next_enemy), hl

destroy_heroBullet:
	ld 	a, #-1 					;; Indicamos que se ha borrado 
	ld 	(bullet_erased), a

	ld 	hl, (m_next_heroBullet)
	ld 	(next_entity), hl

	ld 	hl, #m_num_heroBullets
	ld 	bc, #k_bullet_size

	call 	ent_deleteEntity

	ld 	hl, (next_entity)
	ld 	(m_next_heroBullet), hl

	ld 	bc, #k_bullet_size
	push 	ix
	pop 	hl
	sbc 	hl, bc
	push 	hl
	pop 	ix

fin_checkColisionFHB:
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MUEVE UNA BALA
;; REGISTROS DESTRUIDOS: 
;; ENTRADA: 
;; 		IX -> Bala a mover
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_moveBullet:
	ld 	a, be_dirX(ix)
	sub  	#k_derecha
	jr 	z, move_bulletX
		ld 	a, be_dirX(ix)
		sub 	#k_izquierda
		jr 	z, move_bulletX
			jr 	check_mBulletY

move_bulletX:
	ld 	c, be_dirX(ix)
	ld 	a, e_movsX(ix)
	ld 	(movs_bullet), a
	checkColisionX = . + 1
	call 	ent_checkColisionForHeroBullet

	ld 	a, (bullet_erased)
	add 	#1
	ld 	(bullet_erased), a
	jr 	z, fin_moveBullet

	ld 	e_vx(ix), d

	call 	ent_move
	ld 	e_vx(ix), #0

check_mBulletY:
	ld 	a, be_dirY(ix)
	sub  	#k_arriba
	jr 	z, move_bulletY
		ld 	a, be_dirY(ix)
		sub 	#k_abajo
		jr 	z, move_bulletY
			jr 	fin_moveBullet

move_bulletY:
	ld 	c, be_dirY(ix)
	ld 	a, e_movsY(ix)
	ld 	(movs_bullet), a
	checkColisionY = . + 1
	call 	ent_checkColisionForHeroBullet

	ld 	a, (bullet_erased)
	add 	#1
	ld 	(bullet_erased), a
	jr 	z, fin_moveBullet

	ld 	e_vy(ix), d

	call 	ent_move
	ld 	e_vy(ix), #0

fin_moveBullet:
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; INICIALIZA LA DIRECCION DE UNA BALA 
;; REGISTROS DESTRUIDOS: 
;; ENTRADA: 
;; 		IY -> Bala a inicializar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_initEnemyBulletDir:
	ld 	ix, #hero_data

	ld 	a, de_x(ix)
	ld 	b, de_x(iy)
	cp 	b
	jr 	c, ir_izquierdaBullet
		;; Derecha
		ld 	a, #k_derecha
		ld 	be_dirX(iy), a
		jr 	check_ir_arribaBullet

ir_izquierdaBullet:
	ld 	a, #k_izquierda
	ld 	be_dirX(iy), a

check_ir_arribaBullet:
	ld 	a, de_y(ix)
	ld 	b, de_y(iy)
	cp 	b
	jr 	c, ir_arribaBullet
		;; Abajo
		ld 	a, #k_abajo
		ld 	be_dirY(iy), a
		jr 	fin_initEnemyBulletDir

ir_arribaBullet:
	ld 	a, #k_arriba
	ld 	be_dirY(iy), a

fin_initEnemyBulletDir:
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; INICIALIZA LA DIRECCION DE UNA BALA 
;; REGISTROS DESTRUIDOS: 
;; ENTRADA: 
;; 		IY -> Bala a inicializar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_initHeroBulletDir:
	ld 	a, (m_bullet_X)
	ld 	be_dirX(iy), a

	ld 	a, (m_bullet_Y)
	ld 	be_dirY(iy), a

	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; INICIALIZA LA POSICION DE UNA BALA
;; REGISTROS DESTRUIDOS: 
;; ENTRADA: 
;; 		IX -> Puntero a entidad
;; 		IY -> Bala a inicializar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_initBulletPos:
	ld 	a, de_w(ix)		;; A = ancho de la entidad que dispara
	sra 	a 					;; Lo dividimos entre 2
	add 	de_x(ix) 		;; Le sumamos la pos en X
	 					
	ld 	de_x(iy), a 	;; Inicializamos la X de la bala

	ld 	a, de_h(ix)		;; A = alto de la entidad que dispara
	sra 	a 					;; Lo dividimos entre 2
	add 	de_y(ix) 		;; Le sumamos la pos en Y

	ld 	de_y(iy), a 	;; Inicializamos la Y de la bala

	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GENERA UNA NUEVA BALA E INICIALIZA SU POSICION
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA:
;; 		 IX -> Puntero a entidad que dispara
;;			 HL -> Dir. del numero de balas actuales
;; 		 B -> Num. max de balas 
;; 		
;;			next_entity -> Direccion de la etiqueta de
;;								la siguiente entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_generateEnemyBullet:
	ld 	a, (hl)
	cp 	b
	jr 	z, fin_generateEnemyBullet
		ld 	a, ce_tFire(ix)
		add 	#0
		jr 	nz, decrementa_tFire_Enemy

			ld 	bc, #k_bullet_size
			push 	hl
			ld 	hl, (m_next_enemyBullet)
			ld 	(next_entity), hl
			pop 	hl

			call 	ent_new
			push 	hl
			ld 	hl, (next_entity)
			ld 	(m_next_enemyBullet), hl
			pop 	hl

			ex 	de, hl
			ld 	h, enem_b_h(ix)
			ld 	l, enem_b_l(ix)

			push 	de
			call 	ent_copy
			pop 	de

			.db #0xFD, #0x62 	 ;; D -> IYh
		   .db #0xFD, #0x6B   ;; E -> IYl

		   call 	ent_initBulletPos
		   push 	ix 
		   call 	ent_initEnemyBulletDir
		   pop 	ix

		   ;ld 	a, ce_tMaxF(ix)
		   ld 	a, (m_tMax_fire)
		   ld 	ce_tFire(ix), a
		   jr 	fin_generateEnemyBullet

decrementa_tFire_Enemy:
	ld 	a, ce_tFire(ix) 
	dec 	a
	ld 	ce_tFire(ix), a

fin_generateEnemyBullet:
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GENERA UNA NUEVA BALA E INICIALIZA SU POSICION
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA:
;; 		 IX -> Puntero a entidad que dispara
;;			 HL -> Dir. del numero de balas actuales
;; 		 B -> Num. max de balas 
;; 		
;;			next_entity -> Direccion de la etiqueta de
;;								la siguiente entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_generateHeroBullet:
	ld 	a, (hl)
	cp 	b
	jr 	z, fin_generateBullet
		ld 	a, ce_tFire(ix)
		add 	#0
		jr 	nz, decrementa_tFire_Hero

			ld 	bc, #k_bullet_size
			push 	hl
			ld 	hl, (m_next_heroBullet)
			ld 	(next_entity), hl
			pop 	hl

			call 	ent_new
			push 	hl
			ld 	hl, (next_entity)
			ld 	(m_next_heroBullet), hl
			pop 	hl

			ex 	de, hl
			ld 	hl, #heroBullet_data

			push 	de
			call 	ent_copy
			pop 	de

			.db #0xFD, #0x62 	 ;; D -> IYh
		   .db #0xFD, #0x6B   ;; E -> IYl

		   call 	ent_initBulletPos
		   call 	ent_initHeroBulletDir

		   ld 	a, ce_tMaxF(ix)
		   ld 	ce_tFire(ix), a
		   jr 	fin_generateBullet

decrementa_tFire_Hero:
	ld 	a, ce_tFire(ix) 
	dec 	a
	ld 	ce_tFire(ix), a

fin_generateBullet:
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ACTUALIZA LAS ENTIDADES DEL JUEGO
;; REGISTROS DESTRUIDOS: AF, HL, BC, DE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_updateEntities:
	ld 	bc, #k_bullet_size
	ld 	ix, #heroBullet_vector

   ld 	a, (m_num_heroBullets)
   ld 	hl, #ent_update
   push 	ix
   call  ent_doForAll
   pop 	ix

   ld 	a, (m_num_heroBullets)
   ld 	hl, #rend_drawEntity
   call  ent_doForAll


	ld 	ix, #enemyBullet_vector

   ld 	a, (m_num_enemyBullets)
   ld 	hl, #ent_update
   push 	ix
   call  ent_doForAll
   pop 	ix

   ld 	a, (m_num_enemyBullets)
   ld 	hl, #rend_drawEntity
   call  ent_doForAll

   ld 	bc, #k_enemy_size
	ld 	ix, #enemy_vector

   ld 	a, (m_num_enemies)
   ld 	hl, #ent_update
   push 	ix
   call  ent_doForAll
   pop 	ix

   ld 	a, (m_num_enemies)
   ld 	hl, #rend_drawEntity
   call  ent_doForAll

	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GENERA UNA POSICION ALEATORIA DENTRO DEL LIMITE
;; DEL MAPA
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA: 
;; 		IX -> Puntero a la entidad para la cual se
;; 				genera
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_randomPos:
	call 	cpct_getRandom_mxor_u16_asm

	ld 	a, #k_limit_down_y
	sub 	de_h(ix)
	ld 	b, a
	ld 	a, h
fuera_y:
	cp 	b
	jr 	c, check_randomX
		;; fuera del limite
		sub 	#k_limit_down_y
		jr 	fuera_y

check_randomX:
	ld 	b, #k_limit_up_y
	cp 	b
	jr 	c, es_limite_y
		ld 	enem_nextY(ix), a
		jr 	rand_x

es_limite_y:
	ld 	enem_nextY(ix), b

rand_x:
	ld 	a, #k_limit_der_x
	sub 	de_w(ix)
	ld 	b, a
	ld 	a, l
fuera_x:
	cp 	b
	jr 	c, fin_randomPos
		;; Fuera del limite
		sub 	#k_limit_der_x
		jr 	fuera_x

fin_randomPos:
	ld 	b, #k_limit_izq_x
	cp 	b
	jr 	c, es_limite_x
		ld 	enem_nextX(ix), a
		jr 	fin_rPos

es_limite_x:
	ld 	enem_nextX(ix), b

fin_rPos:
	ret 


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SPAWNEA UNA ENTIDAD CADA CIERTO TIEMPO
;; REGISTROS DESTRUIDOS: AF, HL, BC, DE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_spawnearEnemy:
	ld 	a, (m_num_enemies_pant)
	ld 	b, a
	ld 	a, (m_num_enemies) 				;; Num. enemigos actual
	sub 	b										;; Num. max de enemigos
	jr 	z, fin_spawnear 					;; Z=1, limite
		ld 	a, (m_num_total_enemies)
		add 	#0
		jr 	z, fin_spawnear
			ld 	a, (m_t_spawn) 			;; A = tiempo para spawnear
			dec 	a  							;; Decrementamos
			ld 	(m_t_spawn), a 			;; Actualizamos 
			jr 	z, spawnear_entidad 		;; Z=1, momento de spawnear
				jr 	fin_spawnear 

spawnear_entidad:
	ld 	a, (m_num_total_enemies)
	sub 	#1
	ld 	(m_num_total_enemies), a

	call ent_generateEnemy 					;; Generamos enemigo
	ld 	a, (m_t_max_spawn)				;; Reseteamos el tiempo del spawn
	ld 	(m_t_spawn), a

fin_spawnear:
	ret

k_spw_w_3 = 3
k_spw_w_8 = 8

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GENERA UNA NUEVA ENTIDAD EN UN SPAWN DETERMINADO
;; REGISTROS DESTRUIDOS: AF, HL, BC, DE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_generateEnemy:
	ld 	a, (m_num_enemies_pant) ;; Max num entidades
	ld 	b, a
   ld    a, (m_num_enemies) 		;; Num enemigos actuales					 	
   cp 	b
   jp 	z, fin_generar 			;; Z=1, ha llegado al max de entidades
   	ld 	hl, (m_next_enemy) 	;; HL -> Next enemy
   	ld 	(next_entity), hl 	;; Ponemos en next_entity HL

   	ld 	hl, #m_num_enemies 		;; Puntero a num entidades actuales
   	ld    bc, #k_enemy_size  		;; Cargamos el tamanyo de la entidad a crear y copiar

	   call 	ent_new 						;; Registramos la entidad -> HL
	   push 	hl
	   ld 	hl, (next_entity) 		;; HL -> Nuevo next_entity
	   ld 	(m_next_enemy), hl 		;; Actualizamos el next enemy
	   pop 	hl

 		ex   	de, hl 						;; Cambiamos HL y DE

 		;; ELECCION DE ENEMIGO
spider_enemy:
	   ld 		a, (change_enemy)		;; Cargamos la variable que nos indica el cambio de enemigo
	   dec 		a 						;; Decrementamos la variable
	   jr 		nz, bomb_enemy  			;; Comprobamos que enemigo tenemos que copiar
		   ld   		hl, #enemy_data 			;; Ponemos en HL el modelo a copiar
		   add 		#4
		   ld 		(change_enemy), a 			;; Cargamos el valor a la variable
		   jr 		continue
bomb_enemy:
	   dec 		a
	   jr 		nz, tower_enemy
		   inc 		a
		   ld 		(change_enemy), a

		   ;; WAVE <= 5, solo spider
		   ld 	a, (m_num_wave)
		   cp 	#k_spw_w_3
		   jr 	z, spider_enemy
		   jr 	c, spider_enemy

		   ld   		hl, #enemy_bomb_data			;; Ponemos en HL el modelo a copiar
		   jr 		continue
tower_enemy:
	   ld 		(change_enemy), a

	   ;; WAVE <= 5, solo spider
	   ld 	a, (m_num_wave)
	   cp 	#k_spw_w_3
	   jr 	z, spider_enemy
	   jr 	c, spider_enemy

	   ;; WAVE <= 10, solo spider o bomb
	   ld 	a, (m_num_wave)
	   cp 	#k_spw_w_8
	   jr 	z, spider_enemy
	   jr 	c, spider_enemy

	   ld   	hl, #enemy_tower_data 			;; Ponemos en HL el modelo a copiar

	  	push 	de
	   call 	ent_copy 					;; Copiamos el modelo en la nueva entidad
	   pop 	de

	   .db #0xDD, #0x62 	 				;; D -> IXh
	   .db #0xDD, #0x6B   				;; E -> IXl

	   call 	ent_randomPos
	   ld 	a, enem_nextX(ix)
	   ld 	de_x(ix), a
	   ld 	a, enem_nextY(ix)
	   ld 	de_y(ix), a
	   jr 	fin_generar
continue:
	   push 	de
	   call 	ent_copy 					;; Copiamos el modelo en la nueva entidad
	   pop 	de

	   .db #0xDD, #0x62 	 				;; D -> IXh
	   .db #0xDD, #0x6B   				;; E -> IXl

	   ld 	iy, #hero_data 			;; A partir de aqui se asigna un spawn
	   ld 	h, de_x(iy)
	   ld 	d, de_y(iy)
	   call 	cpct_setSeed_mxor_asm
	   call 	cpct_getRandom_mxor_u16_asm
	   ld 	de, #0x5555
	   sbc 	hl, de
	   jr 	c, spawn_izquierdo
	   	sbc 	hl, de
	   	jr 	c, spawn_superior
	   		;; Spawn derecho
	   		ld 	a, #k_spw_der_x
	   		sub 	de_w(ix)
	   		ld 	de_x(ix), a
	   		ld 	de_y(ix), #k_spw_der_y
	   		jr 	fin_generar

spawn_izquierdo:
	ld 	de_x(ix), #k_spw_izq_x
	ld 	de_y(ix), #k_spw_izq_y
	jr 	fin_generar

spawn_superior:
	ld 	de_x(ix), #k_spw_sup_x
	ld 	de_y(ix), #k_spw_sup_y

fin_generar:
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ELIMINA UNA ENTIDAD EXISTENTE
;; REGISTROS DESTRUIDOS: AF, HL, BC
;; ENTRADA:
;; 		IX -> Puntero a la entidad a borrar
;; 		HL -> Puntero al numero de entidades
;; 		BC -> Tamanyo de la entidad 
;;
;; 		next_entity -> Siguiente entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_deleteEntity:
	push 	bc        
	push 	hl
	call	rend_clearEntity 	;; Borramos la entidad a eliminar
	pop 	hl
	pop 	bc

	ld 	a, (hl) 				;; A = Numero de entidades actual
	sub 	#1 					;; Restamos 1
	jr 	z, solo_hay_una 	;; Z=1, solo habia una entidad
		call 	ent_delete	 	;; Z=0, habia mas de una entidad

		;; En hl ya esta next_entity
		.db 	#0xDD, #0x54 				;; IXh -> D
		.db 	#0xDD, #0x5D 				;; IXl -> E
		sbc 	hl, de 						;; Restamos HL y BC para obtener la pos de inicio de la ultima
		jr 	z, fin_deleteEntity 		;; Z=1, Era la ultima
			;; Esta en medio del vector
			ld 	hl, (next_entity) 	;; HL -> origen -> la siguiente de la ultima
			call 	ent_copy 				;; En DE ya esta el destino (entidad a borrar), copiamos la ultima en DE
			jr 	fin_deleteEntity

solo_hay_una:
	call 	ent_delete 

fin_deleteEntity:
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ELIMINA UNA ENTIDAD EXISTENTE
;; REGISTROS DESTRUIDOS: AF, HL, BC
;; ENTRADA:
;; 		HL -> Puntero al numero de entidades
;; 		BC -> Tamanyo de la entidad 
;;
;; 		next_entity -> Direccion de la eqtiqueta
;; 							de la sig. entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_delete:
	ld    a, (hl) 					;; Num entidades actuales
 	dec 	a 							;; Decrementamos A para eliminar una entidad
 	ld    (hl), a 					;; Actualizamos el num de entidades actuales

 	ld    hl, (next_entity) 	;; Cargamos el puntero a la siguiente entidad del vector
 	sbc   hl, bc 					;; Obtenemos la pos de la siguiente entidad
 	ld    (next_entity), hl 	;; Actualizamos el puntero

	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; REGISTRA UNA NUEVA ENTIDAD
;; REGISTROS DESTRUIDOS: AF, HL
;; ENTRADA:
;; 		HL -> Puntero al numero de entidades
;; 		BC -> Tamanyo de la entidad
;;
;; 		next_entity -> Direccion de la eqtiqueta
;; 							de la sig. entidad
;; SALIDA: 
;; 		HL -> Puntero a la entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_new:
   ld    a, (hl) 						;; Num entidades actuales
 	inc 	a 								;; Incrementamos A para crear una entidad
 	ld    (hl), a 						;; Actualizamos el num de entidades actuales

 	ld    hl, (next_entity) 		;; Cargamos el puntero a la siguiente entidad del vector
 	add   hl, bc 						;; Obtenemos la pos de la siguiente entidad
 	ld    (next_entity), hl 		;; Actualizamos el puntero
 	or    a       						;; Da a pero no devuelve acarreo
 	sbc   hl, bc 						;; Recuperamos HL (puntero a la entidad creada)

   ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; COPIA LOS VALORES DE UNA ENTIDAD SOBRE OTRA
;; REGISTROS DESTRUIDOS: 
;; ENTRADA: 
;;      HL -> entidad origen
;;      DE -> entidad destino
;; 	  BC -> Tamanyo de la entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_copy:
    ldir       ; HL -> origen, DE -> destino, BC -> tamanyo a copiar (hasta que llega a 0)
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ACCION PARA TODAS LAS ENTIDADES
;; REGISTROS DESTRUIDOS: AF, BC, IX
;; ENTRADA: 
;; 		HL -> Puntero al metodo a ejecutar
;; 		 A -> numero de entidades actuales
;; 		BC -> Tamanyo de las entidades
;; 		IX -> Puntero al vector de entidades
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_doForAll:
    add 	#0
    jr 	z, fin_doForAll
    	ld   (metodo), hl

buc:
    push  	af
    push 	bc 	
    metodo = . + 1
    call  	rend_drawEntity
    pop 	 	bc
    pop 	 	af
    add   	ix, bc

    dec   a
    jr   nz, buc

fin_doForAll:
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ACTUALIZAR UNA ENTIDAD
;; REGISTROS DESTRUIDOS: HL
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_update:
   ld     h, e_up_h(ix)
   ld     l, e_up_l(ix)
   jp    (hl)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ACTUALIZA EL MINIMO MOVIMIENTO QUE PUEDE REALIZAR
;; UNA ENTIDAD
;; REGISTROS DESTRUIDOS: AF, D
;; ENTRADA: 
;; 		 C -> Direccion a la que quiere moverse
;; 		 D -> Posiciones que se quiere mover
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_actualizaMinMov:
	ld 	a, c 							;; Cargo la direccion del movimiento en A
	sub 	#k_izquierda 				;; Compruebo si es izquierda
	jr 	z, minMovLoU 				;; Z=1 -> es izquierda
		ld 	a, c 
		sub 	#k_derecha
		jr 	z, minMovRoD 			;; Z=1 -> es derecha
			ld 	a, c 
			sub 	#k_abajo
			jr 	z, minMovRoD  		;; Z=1 -> es abajo
				;; Arriba 				;; Z=0 -> es arriba
minMovLoU:
	ld 	a, d
	neg
	ld 	d, a
	ld 	a, (m_min_mov) 			;; A = min mov por ahora
	neg 
	cp 	d 								;; A - D
	jr 	c, fin_actualizaMinMov 	;; Si A>D, no actualizar (ej. A=minMov=-1, D=-3)
		ld 	a, d 							;; A = D
		neg
		ld 	(m_min_mov), a 			;; Actualizamos el min Mov
		jr fin_actualizaMinMov

minMovRoD:
	ld 	a, (m_min_mov) 				;; A = min mov por ahora
	cp 	d
	jr 	c, fin_actualizaMinMov 		;; Si A<D, no actualizar (ej. A=minMov=2, D=3)
		ld 	a, d 							;; A = D
		ld 	(m_min_mov), a 			;; Actualizamos el min Mov

fin_actualizaMinMov:
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DETECTA SI LA ENTIDAD IX COLISIONA CONTRA OTRA
;; ENTIDAD SEGUN EL MOVIMIENTO QUE QUIERE REALIZAR
;; REGISTROS DESTRUIDOS: AF, BC, DE, IY
;; ENTRADA: 
;; 		IX -> Puntero a entidad
;; 		 C -> Direccion a la que quiere moverse IX
;; SALIDA:
;; 		D -> Numero de posiciones a mover
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_checkColisionForEnemy:
	call 	ent_checkColisionMap 	;; Detecta colision con el mapa

	ld 	iy, #hero_data 			;; Carga la direccion del heroe
	call 	ent_checkColisionEnt		;; Comprueba colision con heroe

	ld 	a, d 							;; A=num posiciones que se puede mover actualmente
	ld 	(m_min_mov), a 			;; Lo almacenamos en una variable

	add 	#0
	jr 	z, fin_checkColisionFE

	ld 	iy, #enemy_vector 		;; Carga la direccion del vector de entidades

	ld 	a, (m_num_enemies)				;; Cargamos en A el numero de entidades actuales
	sub 	#0 							;; Le restamos 0
	jr 	z, fin_checkColisionFE 	;; Z=1, no hay entidades
		ld 	h, de_x(ix) 				;; H=pos en x de IX
		ld 	l, de_y(ix) 				;; L=pos en y de IX
buclde_colisionFE:
		ld 	d, de_x(iy) 				;; D=pos en x de IY
		ld 	e, de_y(iy) 				;; E=pos en y de IY
		sbc  	hl, de 					;; Restamos HL y DE con carry
		jr 	z, decrementa_a 		;; Z=1, IX = IY
			;; IX != IY
			ex 	af, af'                  
			call 	ent_checkColisionEnt ;; Comprobamos colision con IY
			call 	ent_actualizaMinMov  ;; Actualizamos el min mov que puede hacer IX
			add 	#0
			jr 	z, fin_checkColisionFE
				ex 	af, af' 

decrementa_a:
		dec 	a

		push 	bc 
		ld 	bc, #k_enemy_size 	;; BC = Tamanyo entidad
		add 	iy, bc 					;; Avanzamos a la siguiente entidad del vector
		pop 	bc

		jr 	nz, buclde_colisionFE

fin_checkColisionFE:
	ld 	a, (m_min_mov) 	;; Ponemos en a el min mov que puede realizar
	ld 	d, a 					;; Lo ponemos en D

	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DETECTA SI LA ENTIDAD IX COLISIONA CONTRA OTRA
;; ENTIDAD SEGUN EL MOVIMIENTO QUE QUIERE REALIZAR
;; REGISTROS DESTRUIDOS: AF, BC, D
;; ENTRADA: 
;; 		IX -> Puntero a entidad
;; 		 C -> Direccion a la que quiere moverse IX
;; SALIDA:
;; 		D -> Numero de posiciones a mover
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_checkColisionForHero:
	call 	ent_checkColisionMap 	;; Detecta colision con el mapa

	ld 	a, d 							;; A=num posiciones que se puede mover actualmente
	ld 	(m_min_mov), a 			;; Lo almacenamos en una variable

	add 	#0
	jr 	z, fin_checkColisionFH

	ld 	iy, #enemy_vector 		;; IY = vector de entidades

	ld 	a, (m_num_enemies)		;; Cargamos en A el numero de entidades actuales
	sub 	#0 							;; Restamos 0
	jr 	z, fin_checkColisionFH  ;; Z=1, no hay entidades
buclde_colisionFH:
		ex 	af, af'
		call 	ent_checkColisionEnt ;; Comprobamos colision con IY
		call 	ent_actualizaMinMov  ;; Actualizamos el min mov que puede hacer IX
		add 	#0
		jr 	z, fin_checkColisionFH
			ex 	af, af'

		push 	bc
		ld 	bc, #k_enemy_size   ;; Avanzamos a la siguiente
		add 	iy, bc
		pop 	bc

		dec 	a
		jr 	nz, buclde_colisionFH

fin_checkColisionFH:
	ld 	a, (m_min_mov) 	;; Ponemos en a el min mov que puede realizar
	ld 	d, a 					;; Lo ponemos en D

	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DETECTA SI UNA ENTIDAD COLISIONA CON EL BORDE
;; U OTRA ENTIDAD DEL MAPA EN DIRECCION IZQUIERDA O 
;; SUPERIOR DE IX (EN FUNCION DE X POR DEFECTO)
;; REGISTROS DESTRUIDOS: AF, BC, D
;; ENTRADA: 
;; 		IX -> Puntero a entidad (offset de 1 para
;; 				comprobar arriba)
;; 		 A -> Limite del borde o entidad 
;; SALIDA:
;;			D -> Posiciones que se puede mover en la
;; 			  direccion deseada
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_checkColisionLoU:
	ld 	b, de_x(ix) 						;; Carga la pos X en B (o Y en el caso arriba)
	cp 	b
	jr 	z,  colisionLoU 					;; Z=1, colision
	jr 	nc, fin_checkColisionLoU 		;; Comprobamos que IX esta en la posicion correcta respecto a A
		add 	e_movsX(ix) 					;; Suma las posiciones que se quiere mover en X (o Y)
		cp 	b
		jr 	c, max_mov_LoU 				;; A<B, tenemos que poner en D lo que se mueve como max
			sub	e_movsX(ix) 				;; Resta las posiciones que se quiere mover en X (o Y)
			sub 	b 								;; Resta B a A para obtener el valor correcto
			ld 	d, a
			jr 	fin_checkColisionLoU		;; No colision

max_mov_LoU:
	ld 	a, e_movsX(ix)
	neg 
	ld 	d, a
	jr 	fin_checkColisionLoU

colisionLoU:
	ld 	d, #0

fin_checkColisionLoU:
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DETECTA SI UNA ENTIDAD COLISIONA CON EL BORDE
;; U OTRA ENTIDAD DEL MAPA EN DIRECCION DERECHA O 
;; INFERIOR DE IX (EN FUNCION DE X POR DEFECTO)
;; REGISTROS DESTRUIDOS: AF, BC, D
;; ENTRADA: 
;; 		IX -> Puntero a entidad (offset de 1 para
;; 				comprobar abajo)
;; 		 A -> Limite del borde o entidad
;; SALIDA:
;;			D -> Posiciones que se puede mover en la
;; 			  direccion deseada
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_checkColisionRoD:
	ld 	b, de_x(ix) 							;; Carga la pos X en B (o Y en el caso abajo)
	sub 	a, de_w(ix) 							;; Le resta el ancho (o alto) de IX a A
	cp 	b 											;; A-B
	jr 	z, colisionRoD 						;; Z=1, colision, no puede moverse
	jr 	c, fin_checkColisionRoD 			;; Comprobamos que IX esta en la posicion correcta respecto a A
		;; Pos correcta
		sub 	b 										;; A = A-B
		cp 	e_movsX(ix) 						;; A - e_movsX(ix) (o e_movsY)
		jr 	nc, max_mov_RoD 					;; Si A > e_movsX(ix) (o e_movsY) tenemos que poner en D lo que se mueve como max
			ld  	d, a 								;; Actualizamos D
			jr 	fin_checkColisionRoD

max_mov_RoD:
	ld 	d, e_movsX(ix)
	jr 	fin_checkColisionRoD

colisionRoD:
	ld 	d, #0

fin_checkColisionRoD:
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DETECTA SI LA ENTIDAD IX COLISIONA CONTRA OTRA
;; ENTIDAD SEGUN EL MOVIMIENTO QUE QUIERE REALIZAR
;; REGISTROS DESTRUIDOS: AF, BC, D
;; ENTRADA: 
;; 		IX -> Puntero a entidad
;;			IY -> Puntero a otra entidad
;; 		 C -> Direccion a la que quiere moverse IX
;; SALIDA:
;; 		D -> Numero de posiciones que puede 
;;				  moverse en la direccion deseada 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_checkColisionEnt:
										;; Si IX no esta arriba o abajo de IY -> colisionan
	ld 	b, de_y(ix)				;; B = posicion en Y de IX
	ld 	a, de_y(iy) 			;; A = posicion en Y de IY
	add 	de_h(iy) 				;; A = y_iy + h_iy
	cp 	b 							;; Comparamos (A-B)
	jr 	z, no_colision_y
	jr		c, no_colision_y 		;; a<b -> C=1 -> No colisiona en el eje y (IX mas abajo de IY)
		ld 	b, de_y(iy)			;; B = posicion en Y de IY
		ld 	a, de_y(ix)			;; A = posicion en Y de IX
		add 	de_h(ix) 			;; A = y_ix + h_ix
		cp 	b 						;; Comparamos (A-B)
		jr 	z, no_colision_y
		jr 	c, no_colision_y 	;; a<b -> C=1 -> No colisiona en el eje y (IX mas arriba de IY)
			;; Colision eje y
			ld 	a, c 						;; Cargamos en A la direccion de la entidad
			sub 	#k_izquierda 			;; Restamos para ver si es a la izquierda
			jr 	nz, check_derecha  	;; Si Z=0 -> Compruebo derecha
				;; Check izquierda
				ld 	a, de_x(iy) 				;; A = posicion en X de IY
				add 	de_w(iy) 					;; A = x_iy + w_iy
				call 	ent_checkColisionLoU 	;; Comprobamos la colision con la entidad IY a la izquierda
				jr 	continuar	


check_derecha:
	ld 	a, c 								;; Cargamos en A la direccion de la entidad
	sub 	#k_derecha 						;; Restamos para ver si es a la derecha
	jr 	nz, continuar  				;; Si Z=0 -> no colision
		ld 	a, de_x(iy) 				;; A = posicion en X de IY
		call 	ent_checkColisionRoD 	;; Comprobamos la colision con entidad IY a la derecha
		jr continuar 

no_colision_y:
										;; Si IX no esta a la derecha o izquierda de IY -> colisionan
	ld 	b, de_x(ix)				;; B = posicion en X de IX
	ld 	a, de_x(iy) 			;; A = posicion en X de IY
	add 	de_w(iy) 				;; A = x_iy + w_iy
	cp 	b 							;; Comparamos (A-B)
	jr 	z, continuar
	jr		c, continuar			;; a<b -> C=1 -> No colisiona en el eje x (IX mas a la derecha de IY)
		ld 	b, de_x(iy)			;; B = posicion en X de IY
		ld 	a, de_x(ix)			;; A = posicion en X de IX
		add 	de_w(ix) 			;; A = y_ix + h_ix
		cp 	b 						;; Comparamos (A-B)
		jr 	z, continuar
		jr 	c, continuar 		;; a<b -> C=1 -> No colisiona en el eje x (IX mas a la izquierda de IY)
			;; Colision eje x
			ld 	a, c 								;; Cargamos en A la direccion de la entidad
			sub 	#k_arriba 						;; Restamos para ver si es hacia arriba
			jr 	nz, check_abajo  				;; Si Z=0 -> no colision
				ld 	a, de_y(iy) 				;; A = posicion en Y de IY
				add 	de_h(iy) 					;; A = y_iy + h_iy
				inc 	ix 							;; Incrementamos IX para que la rutina este en funcion de Y
				call 	ent_checkColisionLoU 	;; Comprobamos la colision con la entidad IY hacia arriba
				dec 	ix 							;; Dejamos IX como estaba
				jr 	continuar

check_abajo:
	ld 	a, c 									;; Cargamos en A la direccion de la entidad
	sub 	#k_abajo 							;; Restamos para ver si es hacia abajo
	jr 	nz, continuar  					;; Si Z=0 -> no colision
		ld 	a, de_y(iy) 					;; A = posicion en Y de IY
		inc 	ix 								;; Incrementamos IX para que la rutina este en funcion de Y
		call 	ent_checkColisionRoD 		;; Comprobamos la colision con la entidad IY hacia abajo
		dec 	ix 								;; Dejamos IX como estaba
	
continuar:
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DETECTA SI UNA ENTIDAD COLISIONA CON EL BORDE
;; DEL MAPA SEGUN EL MOVIMIENTO A REALIZAR
;; REGISTROS DESTRUIDOS: AF, BC, D
;; ENTRADA: 
;; 		IX -> Puntero a entidad
;; 		 C -> Direccion del movimiento
;; SALIDA:
;;			D -> Posiciones que se puede mover en la
;; 			  direccion deseada
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_checkColisionMap:
	ld 	a, c 											;; Cargo la direccion del movimiento en A
	sub 	#k_izquierda 								;; Compruebo si es izquierda
	jr 	z, es_izquierda 							;; Z=1 -> es izquierda
		ld 	a, c 
		sub 	#k_derecha
		jr 	z, es_derecha 							;; Z=1 -> es derecha
			ld 	a, c 
			sub 	#k_abajo
			jr 	z, es_abajo  						;; Z=1 -> es abajo
				;; Arriba 								;; Z=0 -> es arriba
				ld 	a, #k_limit_up_y 				;; Carga el limite en A
				inc 	ix 								;; Incrementamos IX para que la rutina este en funcion de Y
				call 	ent_checkColisionLoU 		;; Comprobamos la colision con el borde superior
				dec 	ix 								;; Dejamos IX como estaba
				jr 	fin_checkColisionMapa

es_izquierda:
	ld 	a, #k_limit_izq_x 				;; Carga el limite en A
	call 	ent_checkColisionLoU 			;; Comprobamos la colision con el borde izquierdo
	jr 	fin_checkColisionMapa

es_derecha:
	ld 	a, #k_limit_der_x 				;; Carga el limite en A
	call 	ent_checkColisionRoD 			;; Comprobamos la colision con el borde derecho
	jr 	fin_checkColisionMapa

es_abajo:
	ld 	a, #k_limit_down_y 				;; Carga el limite en A
	inc 	ix 									;; Incrementamos IX para que la rutina este en funcion de Y
	call 	ent_checkColisionRoD 			;; Comprobamos la colision con el borde inferior
	dec 	ix 									;; Dejamos IX como estaba

fin_checkColisionMapa:
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MINIMO MOV. DE UN ENEMIGO A UNA POS RANDOM
;; REGISTROS DESTRUIDOS: AF, D
;; ENTRADA: 
;;	 		IX -> Puntero a entidad
;;			 D -> Num. de posiciones a mover
;; 		 A -> Num. max. de posiciones a mover
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_minMoveEnemyRandom:
	cp 	d
	jr 	z,  fin_minMoveEnenmyRandom
	jr 	nc, fin_minMoveEnenmyRandom
		ld 	d, a

fin_minMoveEnenmyRandom:
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MOVER UNA ENTIDAD ENEMIGA A UNA POS RANDOM
;; REGISTROS DESTRUIDOS: AF, BC
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_moveEnemyRandom:
		ld 	a, enem_tMove(ix) 				;; A = tiempo para next mov
		ld 	b, enem_tMaxM(ix) 				;; B = tiempo max. para next mov
		cp 	b 
		jr 	nz, check_moveEnemyRandom 		;; Si Z=0, no generamos nueva posicion random
		;; Hay que generar pos aleatoria 	;; Z=1, nueva pos random
nueva_pos:
		push 	af
		call 	ent_randomPos 						;; Generamos nueva pos random
		pop 	af

check_moveEnemyRandom:
	ld 	a, enem_nextX(ix) 					;; Siguiente X
	ld 	b, de_x(ix) 							;; Actual X
	cp 	b
	jr 	z, check_ir_arribaRand 				;; Si son iguales no necesita moverse mas en X
	jr 	c, ir_izquierdaRand 					;; Siguiente X esta a la izq de Actual X
		;; Derecha
		ld 	c, #k_derecha 						;; Estaba a la derecha
		call 	ent_checkColisionForEnemy 		;; Comprobamos colisiones

		ld 	a, enem_nextX(ix) 				;; Siguiente X
		sub	de_x(ix) 							;; Actual X
		call 	ent_minMoveEnemyRandom

		ld 	e_vx(ix), d 						;; Actualizamos velocidad X
		jr 	check_ir_arribaRand

ir_izquierdaRand:
	ld 	c, #k_izquierda 						;; Estaba a la izquierda
   call 	ent_checkColisionForEnemy 			;; Comprobamos colisiones

   ld 	a, d
   neg
   ld 	d, a
   ld 	a, de_x(ix) 							;; Actual X
	sub	enem_nextX(ix) 						;; Siguiente X
   call 	ent_minMoveEnemyRandom
   ld 	a, d
   neg

	ld 	e_vx(ix), a 							;; Actualizamos velocidad X

check_ir_arribaRand:
	call 	ent_move 								;; Nos movemos en el eje X

	ld e_vx(ix), #0 								;; Lo ponemos a 0 para no movernos constantemente

	ld 	a, enem_nextY(ix) 					;; Siguiente Y
	ld 	b, de_y(ix) 							;; Actual Y
	cp 	b 
	jr 	z, check_waitMoveRandom 			;; Si son iguales no necesita moverse en este eje
	jr 	c, ir_arribaRand 						;; Siguiente Y esta arriba de Actual Y
		;; Abajo
		ld 	c, #k_abajo 					 	;; Estaba abajo
		call 	ent_checkColisionForEnemy 		;; Comprobamos colisiones

		ld 	a, enem_nextY(ix) 				;; Siguiente Y
		sub	de_y(ix) 							;; Actual Y
		call 	ent_minMoveEnemyRandom

		ld 	e_vy(ix), d 						;; Actualizamos la velocidad Y
		jr 	moveEnemyRand

ir_arribaRand:
	ld 	c, #k_arriba 							;; Estaba arriba
	call 	ent_checkColisionForEnemy 			;; Comprobamos colisiones

	ld 	a, d
   neg
   ld 	d, a
   ld 	a, de_y(ix) 							;; Actual Y
	sub	enem_nextY(ix) 						;; Siguiente Y
   call 	ent_minMoveEnemyRandom
   ld 	a, d
   neg

	ld 	e_vy(ix), a 							;; Actualizamos velocidad Y

moveEnemyRand:
	call 	ent_move 								;; Nos movemos en Y

   ld e_vy(ix), #0 							 	;; Lo ponemos a 0 para no movernos constantemente

check_waitMoveRandom:
   ld 	a, enem_tMove(ix) 					;; Cargamos el time to move actual
   dec 	a 											;; Lo decrementamos
   jr 	z, reset_tMove 						;; Si es 0 lo reseteamos
   	ld 	enem_tMove(ix), a 				;; No es 0 por lo que actualizamos
   	jr  	fin_moveEnemyRandom

reset_tMove:
	;ld 	a, enem_tMaxM(ix)
	ld 	a, (m_tMax_move_SP)
	ld 	enem_tMove(ix), a

fin_moveEnemyRandom:
	ld 	a, ce_tMaxF(ix)
	ld 	(m_tMax_fire), a
	call 	ent_fireEnemy

	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MOVIMIENTO DE LA TORRE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_moveTower:
	ld 	a, ce_tMaxF(ix)
	ld 	(m_tMax_fire), a
	call 	ent_fireEnemy
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DISPARO ENEMIGO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_fireEnemy:
	ld 	hl, #m_num_enemyBullets 		;; HL -> numero de balas actuales de enemy
	ld 	b, #k_max_num_enemyBullets 	;; B -> Numero max de balas de enemy
	call 	ent_generateEnemyBullet 		;; Generamos una bala nueva

	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CONTROLAR UNA ENTIDAD CON TECLADO
;; REGISTROS DESTRUIDOS: HL, AF, BC, D
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_fireKeyboard:
	call  cpct_scanKeyboard_asm

   ld    hl, #Key_J			 				;; Apuntar a la izquierda 
   call  cpct_isKeyPressed_asm			;; Comprueba si esta pulsada
   jr    z, left_no_pulsada				;; flag Z=1 -> No esta pulsada
   	ld 	a, #k_izquierda 				;; Ponemos la direccion en a
   	ld 	(m_bullet_X), a		 		;; Guardamos la direccion en la que dispara
   	ld 	a, #0 							;; A = 0
   	ld 	(m_bullet_Y), a 				;; Lo ponemos a 0 para limpiar valores anteriores

left_no_pulsada:
   ld    hl, #Key_L							;; Apuntar a la derecha
   call  cpct_isKeyPressed_asm
   jr    z, right_no_pulsada
   	ld 	a, #k_derecha 					;; Ponemos la direccion en a
   	ld 	(m_bullet_X), a		 		;; Guardamos la direccion en la que dispara
   	ld 	a, #0
   	ld 	(m_bullet_Y), a

right_no_pulsada:
	ld    hl, #Key_K							;; Apuntar hacia abajo
   call  cpct_isKeyPressed_asm
   jr    z, down_no_pulsada		
		ld 	a, (m_bullet_Y) 				;; Ponemos en A el valor actual de la direccion en Y de la bala
		add 	#0 								;; Le sumamos 0
		jr 	z, upd_bulletY_down 			;; Z=1, se ha pulsado izq o der y por tanto ahora es 0
   		ld 	a, #0 						;; Si no era 0 entonces no se ha pulsado izq o der antes de este
   		ld 	(m_bullet_X), a 			;; Ponemos a 0 la dir en X

upd_bulletY_down:
	ld 	a, #k_abajo							;; Ponemos la direccion en a
   ld 	(m_bullet_Y), a		 			;; Guardamos la direccion en la que dispara	

down_no_pulsada:
	ld    hl, #Key_I 			 				;; Movimiento hacia arriba -> Tecla W pulsada
   call  cpct_isKeyPressed_asm
   jr    z, up_no_pulsada	
   	ld 	a, (m_bullet_Y) 				;; Ponemos en A el valor actual de la direccion en Y de la bala
		add 	#0 								;; Le sumamos 0
		jr 	z, upd_bulletY_up 			;; Z=1, se ha pulsado izq o der y por tanto ahora es 0
	   	ld 	a, #0 						;; Si no era 0 entonces no se ha pulsado izq o der antes de este
	   	ld 	(m_bullet_X), a		 	;; Ponemos a 0 la dir en X
 
upd_bulletY_up:
	ld 	a, #k_arriba						;; Ponemos la direccion en a
	ld 	(m_bullet_Y), a		 			;; Guardamos la direccion en la que dispara

up_no_pulsada:

   ld 	hl, #Key_Space 					;; Disparo al pulsar espacio
   call 	cpct_isKeyPressed_asm
   jr 	z, space_no_pulsado
   	ld 	hl, #m_num_heroBullets 		;; HL -> numero de balas actuales de hero
   	ld 	b, #k_max_num_heroBullets 	;; B -> Numero max de balas de hero
   	call 	ent_generateHeroBullet 			;; Generamos una bala nueva

space_no_pulsado:
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CONTROLAR UNA ENTIDAD CON TECLADO
;; REGISTROS DESTRUIDOS: HL, AF, BC, D
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_controlKeyboard:
   call  cpct_scanKeyboard_asm

   ld    hl, #Key_A 							;; Movimiento a la izquierda -> Tecla A pulsada
   call  cpct_isKeyPressed_asm			;; Comprueba si esta pulsada
   jr    z, a_no_pulsada					;; flag Z=1 -> No esta pulsada
	   ld 	c, #k_izquierda 				;; Cargamos la direccion en C
	   call 	ent_checkColisionForHero 	;; Comprobamos la colision -> D=cuanto nos podemos mover
   	ld  	e_vx(ix), d

a_no_pulsada:
   ld    hl, #Key_D 							;; Movimiento a la derecha -> Tecla D pulsada
   call  cpct_isKeyPressed_asm
   jr    z, d_no_pulsada
   	ld 	c, #k_derecha					;; Cargamos la direccion en C
   	call 	ent_checkColisionForHero	;; Comprobamos la colision -> D=cuanto nos podemos mover
   	ld  	e_vx(ix), d			

d_no_pulsada:
	call  ent_move
	ld 	e_vx(ix), #0

	ld    hl, #Key_S 							;; Movimiento hacia abajo -> Tecla S pulsada
   call  cpct_isKeyPressed_asm
   jr    z, s_no_pulsada
		ld 	c, #k_abajo						;; Cargamos la direccion en C
		call 	ent_checkColisionForHero	;; Comprobamos la colision -> D=cuanto nos podemos mover
		ld 	e_vy(ix), d				

s_no_pulsada:
	ld    hl, #Key_W 							;; Movimiento hacia arriba -> Tecla W pulsada
   call  cpct_isKeyPressed_asm
   jr    z, w_no_pulsada
		ld 	c, #k_arriba					;; Cargamos la direccion en C
		call 	ent_checkColisionForHero 	;; Comprobamos la colision -> D=cuanto nos podemos mover
   	ld  	e_vy(ix), d			

w_no_pulsada:
   call  ent_move
   ld 	e_vy(ix), #0

   call 	ent_fireKeyboard 					;; Rutina de disparo

   ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MOVER UNA ENTIDAD
;; REGISTROS DESTRUIDOS: AF
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_move:
   ld    a, de_x(ix) 
   add   e_vx(ix)
   ld    de_x(ix), a

   ld    a, de_y(ix) 
   add   e_vy(ix)
   ld    de_y(ix), a
   
   ret



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MUEVE AL ENEMIGO BOMB
;; REGISTROS DESTRUIDOS: MUCHOS
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_moveEnemyBomb:
	ld 	a, #0
	ld 	(entity_killed), a

	ld 	iy, #hero_data
	ld 	a, de_x(iy)
	sub 	de_x(ix)
	jr 	z, attack_heroe
		ld 	c, #k_abajo 					;; Comprobamos que haya llegado abajo
		call 	ent_checkColisionMap
		jr 	nz, check_up					;; Si no, comprobamos arriba
			ld 	e_vy(ix), d 				;; Se mueve hacia abajo hasta llegar al borde
			ld 	c, #k_derecha 				;; Comprobamos si colisiona con el borde derecho
			call 	ent_checkColisionMap
			jr 	z, check_left 				;; Comprobamos si ha colisionado con el borde derecho
				ld 	a, enem_tMove(ix) 		;; Cargamos en a tMove para saber si se tiene que mover a la derecha o no
				dec 	a
				jr 	nz, check_left 			;; Si da 0 se mueve a la derecha y si no cambia a la izquierda hasta que colisione
					ld 	e_vx(ix), d 				;; Se mueve a la derecha hasta colisionar con el borde
					call 	ent_move
					ret

attack_heroe:
	ld 	c, #k_abajo 					;; Comprobamos que haya llegado abajo
	call ent_checkColisionMap
	jr 	z, is_down
		ld 	c, #k_arriba 					;; Comprobamos que haya llegado abajo
		call ent_checkColisionMap
		jr 	z, is_up
			ld 	a, ce_tFire(ix)
			dec a
			jr 	z, is_up
				jr is_down

is_down:
	ld 	a, #0
	ld 	ce_tFire(ix), a
	ld 	e_vx(ix), a
	call kill_bomb_down
	ld 	a, (entity_killed)
	sub 	#1
	jr 	z, fin_move
		jr 	move_down
is_up:
	ld 	a, #1
	ld 	ce_tFire(ix), a
	ld 	a, #0
	ld 	e_vx(ix), a
	call kill_bomb_up
	ld 	a, (entity_killed)
	sub 	#1
	jr 	z, fin_move
		jr 	move_up

check_left:
	ld 	enem_tMove(ix), #0 				;; Cambiamos la variable para saber que tenemos que seguir moviendonos a la izquierda
	ld 	c, #k_izquierda
	call ent_checkColisionMap
	jr 	z, change_right 				;; Cuando colisione con el borde izquierdo, cambiamos el movimiento a la derecha
		ld 	e_vx(ix), d
		call ent_move
		jr fin_move
change_right:
	ld 	enem_tMove(ix), #1 				;; Cambiamos la variable para saber que tenemos que seguir moviendonos hacia la derecha hasta que colisione con el borde
	jp ent_moveEnemyBomb
check_up:
	ld 	c, #k_arriba
	call ent_checkColisionMap
	jr 	nz, continue_down
		ld 	c, #k_arriba
		call ent_checkColisionMap 		;; Comprobamos si ha colisionado con el borde superior
		ld 	e_vy(ix), d
		ld 	c, #k_derecha
		call ent_checkColisionMap 		;; Comprobamos si colisiona con el borde de la derecha
		jr 	z, check_left 				;; Si colisiona cambiamos a la derecha, si no continua moviendose hacia la derecha
			ld 	a, enem_tMove(ix) 		;; Cargamos en a tMove para saber si se tiene que mover a la derecha o no
			dec a
			jr 	nz, check_left 			;; Si da 0 se mueve a la derecha y si no cambia a la izquierda hasta que colisione
				ld 	e_vx(ix), d
				call ent_move
				jr 	fin_move
continue_down:
	or 	a 				;; Nos aseguramos que el acarreo está desactivados
	ld 	a, de_x(ix) 	;; Cargamos la posicion actual
	sub #40 			;; Comprobamos en que posicion de la pantalla se encuentra
	jr 	c, move_up
move_down:
		ld 	c, #k_arriba
		call ent_checkColisionMap
		ld 	e_vy(ix), d
		call ent_move
		jr 	fin_move
move_up:
	ld 	c, #k_abajo
	call ent_checkColisionMap
	ld 	e_vy(ix), d
	call ent_move
fin_move:
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CUANDO BOMB ESTA ARRIBA MATA AL HEROE
;; REGISTROS DESTRUIDOS: AF
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
kill_bomb_up:
	ld 	iy, #hero_data
	ld 	a, de_x(iy) ;(enemy_position)
	sub 	de_x(ix)
	jr 	nz, fin_kill_bomb_up
		ld 	a, de_y(iy) ;(enemy_positionY)
		cp 	de_y(ix)
		jr 	nc, fin_kill_bomb_up
			add 	de_h(iy)
			cp 	de_y(ix)
			jr 	nc, bomb_explode
				jr 	fin_kill_bomb_up

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CUANDO BOMB ESTA ABAJO MATA AL HEROE
;; REGISTROS DESTRUIDOS: AF
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
kill_bomb_down:
	ld 	iy, #hero_data
	ld 	a, de_x(iy) ;(enemy_position)
	sub 	de_x(ix)
	jr 	nz, fin_kill_bomb_up
		ld 	a, de_y(ix) ;(enemy_positionY)
		cp 	de_y(iy)
		jr 	nc, fin_kill_bomb_up 
			add 	de_h(ix)
			cp 	de_y(iy)
			jr 	c, bomb_explode
				jr 	fin_kill_bomb_up

bomb_explode:
	ld 	b, #2
	call 	ent_damageEntity
	call 	ent_removeHeartHeroStats
	ld 	a, (entity_killed)
	sub 	#1
	jr 	nz, destroy_enemyBomb
		;; Hero ha muerto
		ld 	a, #1
		ld 	(m_game_over), a

destroy_enemyBomb:
	ld 	a, #1
	ld 	(entity_killed), a

	ld 	hl, (m_next_enemy)
	ld 	(next_entity), hl

	ld 	hl, #m_num_enemies
	ld 	bc, #k_enemy_size

	call 	ent_deleteEntity

	ld 	hl, (next_entity)
	ld 	(m_next_enemy), hl


fin_kill_bomb_up:
	ret
