;###########################################################################
;    This file is part of KillingMachine game made by PizzarT.
;
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;
;###########################################################################

;###########################################################################
;#### FICHERO: menu.s
;###########################################################################

.include "cpctelera.h.s"
.include "main.h.s"
.include "render.h.s"
.include "menu.h.s"

killing_machine: .asciz "KILLING MACHINE"
press_space: .asciz "press SPACE"
to_start: .asciz "to START"

game_over: .asciz "GAME OVER"

you_win: .asciz "YOU WIN!"
congrats: .asciz "CONGRATULATIONS!"

press_r: .asciz "Press r to"
to_return: .asciz "return to menu"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DIBUJA UN MENSAJE EN UNA POSICION CONCRETA DE LA
;; PANTALLA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
menu_drawMessage:
	ld   	de, #0xC000
   push  bc
   push  iy
	call 	cpct_getScreenPtr_asm

	call 	cpct_drawStringM0_asm

   ld    de, #0x8000
   pop   iy
   pop   bc
   call  cpct_getScreenPtr_asm

   call  cpct_drawStringM0_asm

	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DIBUJA EL MENSAJE QUE SALE PARA VOLVER AL MENU
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
menu_drawPressToReturn:
   ld    b, #125             
   ld    c, #17
   ld    iy, #press_r
   call  menu_drawMessage 

   ld    b, #145             
   ld    c, #12
   ld    iy, #to_return
   call  menu_drawMessage 

   ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DIBUJA EL MENSAJE QUE SALE AL GANAR
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
menu_drawWinMessage:
   ld    b, #50             
   ld    c, #22
   ld    iy, #you_win
   call  menu_drawMessage 

   ld    b, #80             
   ld    c, #8
   ld    iy, #congrats
   call  menu_drawMessage 

   call  menu_drawPressToReturn

   ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MUESTRA EL MENU AL GANAR
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
menu_win:
   ld    l, #1                      ;; Foreground negro
   ld    h, #0                      ;; Background gris
   call  cpct_setDrawCharM0_asm
   call  menu_drawWinMessage

loop_win:
   call  cpct_scanKeyboard_asm
   call  cpct_isAnyKeyPressed_asm
   ld    hl, #Key_R               
   call  cpct_isKeyPressed_asm
   jr    nz, fin_win
      jr loop_win
   
fin_win:
   ld    l, #0                      ;; Foreground gris
   ld    h, #0                      ;; Background gris
   call  cpct_setDrawCharM0_asm  
   call  menu_drawWinMessage


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DIBUJA EL MENSAJE QUE SALE AL PERDER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
menu_drawGameOverMessage:
   ld    b, #50             
   ld    c, #22
   ld    iy, #game_over
   call  menu_drawMessage 

   call  menu_drawPressToReturn

   ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MUESTRA EL MENU AL PERDER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
menu_gameOver:
   ld    l, #1                      ;; Foreground negro
   ld    h, #0                      ;; Background gris
   call  cpct_setDrawCharM0_asm
   call  menu_drawGameOverMessage

loop_gameOver:
   call  cpct_scanKeyboard_asm
   call  cpct_isAnyKeyPressed_asm
   ld    hl, #Key_R               
   call  cpct_isKeyPressed_asm
   jr    nz, fin_gameOver
      jr loop_gameOver
   
fin_gameOver:
   ld    l, #0                      ;; Foreground gris
   ld    h, #0                      ;; Background gris
   call  cpct_setDrawCharM0_asm  
   call  menu_drawGameOverMessage

   ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MUESTRA EL MENSAJE AL INICIAR EL JUEGO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
menu_drawMainMenuMessage:
   ld    b, #40             
   ld    c, #10
   ld    iy, #killing_machine
   call  menu_drawMessage 

   ld    b, #130             
   ld    c, #16
   ld    iy, #press_space
   call  menu_drawMessage 

   ld    b, #155             
   ld    c, #22
   ld    iy, #to_start
   call  menu_drawMessage 

   ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MUESTRA EL MENU AL INICIAR EL JUEGO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
menu_show:
   ld    l, #1                      ;; Foreground negro
   ld    h, #0                      ;; Background gris
   call  cpct_setDrawCharM0_asm
   call  menu_drawMainMenuMessage

loop:
	call 	cpct_scanKeyboard_asm
	ld    hl, #Key_Space               
   call  cpct_isKeyPressed_asm
	jr 	nz, fin
		jr loop
	
fin:
   ld    l, #0                      ;; Foreground gris
   ld    h, #0                      ;; Background gris
   call  cpct_setDrawCharM0_asm  
   call  menu_drawMainMenuMessage

	ret
